/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifdef _MSC_VER
#pragma hdrstop
#endif

#include <bf_svtools/itemprop.hxx>

#include <unoprnms.hxx>
namespace binfilter {


//#define MAP_CHAR_LEN(cchar) cchar, sizeof(cchar) - 1

const SwPropNameTab aPropNameTab = {

/* 0001 FOLLOW_STYLE */                 {MAP_CHAR_LEN("FollowStyle")},
/* 0002 IS_PHYSICAL */                  {MAP_CHAR_LEN("IsPhysical")},
/* 0003 IS_AUTO_UPDATE */               {MAP_CHAR_LEN("IsAutoUpdate")},
/* 0004 DISPLAY_NAME */                 {MAP_CHAR_LEN("DisplayName")},
/* 0005 PARA_GRAPHIC_URL */             {MAP_CHAR_LEN("ParaBackGraphicURL")},
/* 0006 PARA_GRAPHIC_FILTER */          {MAP_CHAR_LEN("ParaBackGraphicFilter")},
/* 0007 HEADER_GRAPHIC_URL */           {MAP_CHAR_LEN("HeaderBackGraphicURL")},
/* 0008 HEADER_GRAPHIC_FILTER */        {MAP_CHAR_LEN("HeaderBackGraphicFilter")},
/* 0009 FOOTER_GRAPHIC_URL */           {MAP_CHAR_LEN("FooterBackGraphicURL")},
/* 0010 FOOTER_GRAPHIC_FILTER */        {MAP_CHAR_LEN("FooterBackGraphicFilter")},
/* 0011 BACK_GRAPHIC_URL */             {MAP_CHAR_LEN("BackGraphicURL")},
/* 0012 BACK_GRAPHIC_FILTER */          {MAP_CHAR_LEN("BackGraphicFilter")},
/* 0013 BACK_GRAPHIC_LOCATION */        {MAP_CHAR_LEN("BackGraphicLocation")},
/* 0014 BACK_GRAPHIC_BITMAP */          {MAP_CHAR_LEN("BackGraphicBitmap")},
/* 0015 GRAPHIC_URL */                  {MAP_CHAR_LEN("GraphicURL")},
/* 0016 GRAPHIC_FILTER */               {MAP_CHAR_LEN("GraphicFilter")},
/* 0017 GRAPHIC_LOCATION */             {MAP_CHAR_LEN("GraphicLocation")},
/* 0018 GRAPHIC_SIZE */                 {MAP_CHAR_LEN("GraphicSize")},
/* 0019 GRAPHIC_BITMAP */               {MAP_CHAR_LEN("GraphicBitmap")},
/* 0020 BULLET_FONT */                  {MAP_CHAR_LEN("BulletFont")},
/* 0021 PARA_GRAPHIC_LOCATION */        {MAP_CHAR_LEN("ParaBackGraphicLocation")},
/* 0022 HEADER_GRAPHIC_LOCATION */      {MAP_CHAR_LEN("HeaderBackGraphicLocation")},
/* 0023 FOOTER_GRAPHIC_LOCATION */      {MAP_CHAR_LEN("FooterBackGraphicLocation")},
/* 0024 PARA_LEFT_PARA_MARGIN */        {MAP_CHAR_LEN("ParaLeftParaMargin")},
/* 0025 PARA_RIGHT_PARA_MARGIN */       {MAP_CHAR_LEN("ParaRightParaMargin")},
/* 0026 PARA_LEFT_MARGIN */             {MAP_CHAR_LEN("ParaLeftMargin")},
/* 0027 PARA_RIGHT_MARGIN */            {MAP_CHAR_LEN("ParaRightMargin")},
/* 0028 PARA_LEFT_MARGIN_RELATIVE */    {MAP_CHAR_LEN("ParaLeftMarginRelative")},
/* 0029 PARA_RIGHT_MARGIN_RELATIVE */   {MAP_CHAR_LEN("ParaRightMarginRelative")},
/* 0030 PARA_IS_AUTO_FIRST_LINE_INDENT */       {MAP_CHAR_LEN("ParaIsAutoFirstLineIndent")},
/* 0031 PARA_FIRST_LINE_INDENT */       {MAP_CHAR_LEN("ParaFirstLineIndent")},
/* 0032 PARA_FIRST_LINE_INDENT_RELATIVE */      {MAP_CHAR_LEN("ParaFirstLineIndentRelative")},
/* 0033 PARA_IS_HYPHENATION */          {MAP_CHAR_LEN("ParaIsHyphenation")},
/* 0034 PARA_HYPHENATION_MAX_LEADING_CHARS */   {MAP_CHAR_LEN("ParaHyphenationMaxLeadingChars")},
/* 0035 PARA_HYPHENATION_MAX_TRAILING_CHARS */  {MAP_CHAR_LEN("ParaHyphenationMaxTrailingChars")},
/* 0036 PARA_HYPHENATION_MAX_HYPHENS */ {MAP_CHAR_LEN("ParaHyphenationMaxHyphens")},
/* 0037 LEFT_MARGIN */                  {MAP_CHAR_LEN("LeftMargin")},
/* 0038 RIGHT_MARGIN */                 {MAP_CHAR_LEN("RightMargin")},
/* 0039 HEADER_LEFT_MARGIN */           {MAP_CHAR_LEN("HeaderLeftMargin")},
/* 0040 HEADER_RIGHT_MARGIN */          {MAP_CHAR_LEN("HeaderRightMargin")},
/* 0041 FOOTER_LEFT_MARGIN */           {MAP_CHAR_LEN("FooterLeftMargin")},
/* 0042 FOOTER_RIGHT_MARGIN */          {MAP_CHAR_LEN("FooterRightMargin")},
/* 0043 TEXT_RANGE */                   {MAP_CHAR_LEN("TextRange")},
/* 0044 NAME */                         {MAP_CHAR_LEN("Name")},
/* 0045 NUMBERING_ALIGNMENT */          {MAP_CHAR_LEN("NumberingAlignment")},
/* 0046 BULLET_FONT_NAME */             {MAP_CHAR_LEN("BulletFontName")},
/* 0047 BULLET_ID */                    {MAP_CHAR_LEN("BulletId")},
/* 0048 CHAR_STYLE_NAME */              {MAP_CHAR_LEN("CharStyleName")},
/* 0049 ANCHOR_CHAR_STYLE_NAME */       {MAP_CHAR_LEN("AnchorCharStyleName")},
/* 0050 SUFFIX */                       {MAP_CHAR_LEN("Suffix")},
/* 0051 PREFIX */                       {MAP_CHAR_LEN("Prefix")},
/* 0052 PARENT_NUMBERING */             {MAP_CHAR_LEN("ParentNumbering")},
/* 0053 START_WITH */                   {MAP_CHAR_LEN("StartWith")},
/* 0054 CHAR_FONT_NAME */               {MAP_CHAR_LEN("CharFontName")},
/* 0055 CHAR_FONT_STYLE_NAME */         {MAP_CHAR_LEN("CharFontStyleName")},
/* 0056 CHAR_FONT_FAMILY */             {MAP_CHAR_LEN("CharFontFamily")},
/* 0057 CHAR_FONT_CHAR_SET */           {MAP_CHAR_LEN("CharFontCharSet")},
/* 0058 CHAR_FONT_PITCH */              {MAP_CHAR_LEN("CharFontPitch")},
/* 0059 CHAR_POSTURE */                 {MAP_CHAR_LEN("CharPosture")},
/* 0060 CHAR_WEIGHT */                  {MAP_CHAR_LEN("CharWeight")},
/* 0061 CHAR_HEIGHT */                  {MAP_CHAR_LEN("CharHeight")},
/* 0062 CHAR_LOCALE */                  {MAP_CHAR_LEN("CharLocale")},
/* 0063 CHAR_FONT_NAME_ASIAN */         {MAP_CHAR_LEN("CharFontNameAsian")},
/* 0064 CHAR_FONT_STYLE_NAME_ASIAN */   {MAP_CHAR_LEN("CharFontStyleNameAsian")},
/* 0065 CHAR_FONT_FAMILY_ASIAN */       {MAP_CHAR_LEN("CharFontFamilyAsian")},
/* 0066 CHAR_FONT_CHAR_SET_ASIAN */     {MAP_CHAR_LEN("CharFontCharSetAsian")},
/* 0067 CHAR_FONT_PITCH_ASIAN */        {MAP_CHAR_LEN("CharFontPitchAsian")},
/* 0068 CHAR_POSTURE_ASIAN */           {MAP_CHAR_LEN("CharPostureAsian")},
/* 0069 CHAR_WEIGHT_ASIAN */            {MAP_CHAR_LEN("CharWeightAsian")},
/* 0070 CHAR_HEIGHT_ASIAN */            {MAP_CHAR_LEN("CharHeightAsian")},
/* 0071 CHAR_LOCALE_ASIAN */            {MAP_CHAR_LEN("CharLocaleAsian")},
/* 0072 CHAR_FONT_NAME_COMPLEX */       {MAP_CHAR_LEN("CharFontNameComplex")},
/* 0073 CHAR_FONT_STYLE_NAME_COMPLEX */ {MAP_CHAR_LEN("CharFontStyleNameComplex")},
/* 0074 CHAR_FONT_FAMILY_COMPLEX */     {MAP_CHAR_LEN("CharFontFamilyComplex")},
/* 0075 CHAR_FONT_CHAR_SET_COMPLEX */   {MAP_CHAR_LEN("CharFontCharSetComplex")},
/* 0076 CHAR_FONT_PITCH_COMPLEX */      {MAP_CHAR_LEN("CharFontPitchComplex")},
/* 0077 CHAR_POSTURE_COMPLEX */         {MAP_CHAR_LEN("CharPostureComplex")},
/* 0078 CHAR_WEIGHT_COMPLEX */          {MAP_CHAR_LEN("CharWeightComplex")},
/* 0079 CHAR_HEIGHT_COMPLEX */          {MAP_CHAR_LEN("CharHeightComplex")},
/* 0080 CHAR_LOCALE_COMPLEX */          {MAP_CHAR_LEN("CharLocaleComplex")},
/* 0081 CHAR_AUTO_KERNING */            {MAP_CHAR_LEN("CharAutoKerning")},
/* 0082 CHAR_UNDERLINE */               {MAP_CHAR_LEN("CharUnderline")},
/* 0083 CHAR_UNDERLINE_COLOR */         {MAP_CHAR_LEN("CharUnderlineColor")},
/* 0084 CHAR_UNDERLINE_HAS_COLOR */     {MAP_CHAR_LEN("CharUnderlineHasColor")},
/* 0085 CHAR_ESCAPEMENT */              {MAP_CHAR_LEN("CharEscapement")},
/* 0086 CHAR_CASE_MAP */                {MAP_CHAR_LEN("CharCaseMap")},
/* 0087 CHAR_SHADOWED */                {MAP_CHAR_LEN("CharShadowed")},
/* 0088 CHAR_STRIKEOUT */               {MAP_CHAR_LEN("CharStrikeout")},
/* 0089 CHAR_CROSSED_OUT */             {MAP_CHAR_LEN("CharCrossedOut")},
/* 0090 CHAR_NO_HYPHENATION */          {MAP_CHAR_LEN("CharNoHyphenation")},
/* 0091 CHAR_AUTO_ESCAPEMENT */         {MAP_CHAR_LEN("CharAutoEscapement")},
/* 0092 CHAR_PROP_HEIGHT */             {MAP_CHAR_LEN("CharPropHeight")},
/* 0093 CHAR_DIFF_HEIGHT */             {MAP_CHAR_LEN("CharDiffHeight")},
/* 0094 CHAR_PROP_HEIGHT_ASIAN */       {MAP_CHAR_LEN("CharPropHeightAsian")},
/* 0095 CHAR_DIFF_HEIGHT_ASIAN */       {MAP_CHAR_LEN("CharDiffHeightAsian")},
/* 0096 CHAR_PROP_HEIGHT_COMPLEX */     {MAP_CHAR_LEN("CharPropHeightComplex")},
/* 0097 CHAR_DIFF_HEIGHT_COMPLEX */     {MAP_CHAR_LEN("CharDiffHeightComplex")},
/* 0098 CHAR_ESCAPEMENT_HEIGHT */       {MAP_CHAR_LEN("CharEscapementHeight")},
/* 0099 CHAR_COLOR */                   {MAP_CHAR_LEN("CharColor")},

/* 0100 CHAR_FLASH */                   {MAP_CHAR_LEN("CharFlash")},
/* 0101 CHAR_KERNING */                 {MAP_CHAR_LEN("CharKerning")},
/* 0102 CHAR_BACK_COLOR */              {MAP_CHAR_LEN("CharBackColor")},
/* 0103 CHAR_BACK_TRANSPARENT */        {MAP_CHAR_LEN("CharBackTransparent")},
/* 0104 CHAR_COMBINE_IS_ON */           {MAP_CHAR_LEN("CharCombineIsOn")},
/* 0105 CHAR_COMBINE_PREFIX */          {MAP_CHAR_LEN("CharCombinePrefix")},
/* 0106 CHAR_COMBINE_SUFFIX */          {MAP_CHAR_LEN("CharCombineSuffix")},
/* 0107 CHAR_EMPHASIS */                {MAP_CHAR_LEN("CharEmphasis")},
/* 0108 PARA_LINE_SPACING */            {MAP_CHAR_LEN("ParaLineSpacing")},
/* 0109 PARA_TOP_MARGIN */              {MAP_CHAR_LEN("ParaTopMargin")},
/* 0110 PARA_BOTTOM_MARGIN */           {MAP_CHAR_LEN("ParaBottomMargin")},
/* 0111 PARA_TOP_MARGIN_RELATIVE */     {MAP_CHAR_LEN("ParaTopMarginRelative")},
/* 0112 PARA_BOTTOM_MARGIN_RELATIVE */  {MAP_CHAR_LEN("ParaBottomMarginRelative")},
/* 0113 PARA_EXPAND_SINGLE_WORD */      {MAP_CHAR_LEN("ParaExpandSingleWord")},
/* 0114 END_NOTICE */                   {MAP_CHAR_LEN("EndNotice")},
/* 0115 EMBEDDED_OBJECTS */             {MAP_CHAR_LEN("EmbeddedObjects")},
/* 0116 ALPHABETICAL_SEPARATORS */      {MAP_CHAR_LEN("AlphabeticalSeparators")},
/* 0117 BACKGROUND_COLOR */             {MAP_CHAR_LEN("BackgroundColor")},
/* 0118 BEGIN_NOTICE */                 {MAP_CHAR_LEN("BeginNotice")},
/* 0119 CASE_SENSITIVE */               {MAP_CHAR_LEN("CaseSensitive")},
/* 0120 FRAME_STYLE_NAME */             {MAP_CHAR_LEN("FrameStyleName")},
/* 0121 NUMBERING_STYLE_NAME */         {MAP_CHAR_LEN("NumberingStyleName")},
/* 0122 NUMBERING_LEVEL */              {MAP_CHAR_LEN("NumberingLevel")},
/* 0123 NUMBERING_START_VALUE */        {MAP_CHAR_LEN("NumberingStartValue")},
/* 0124 NUMBERING_IS_NUMBER */          {MAP_CHAR_LEN("NumberingIsNumber")},
/* 0125 COMBINE_ENTRIES */              {MAP_CHAR_LEN("CombineEntries")},
/* 0126 COUNT_LINES_IN_FRAMES */        {MAP_CHAR_LEN("CountLinesInFrames")},
/* 0127 DDE_COMMAND_TYPE */             {MAP_CHAR_LEN("DDECommandType")},
/* 0128 DDE_COMMAND_FILE */             {MAP_CHAR_LEN("DDECommandFile")},
/* 0129 DDE_COMMAND_ELEMENT */          {MAP_CHAR_LEN("DDECommandElement")},
/* 0130 IS_AUTOMATIC_UPDATE */          {MAP_CHAR_LEN("IsAutomaticUpdate")},
/* 0131 DEFAULT_TABSTOP_DISTANCE */     {MAP_CHAR_LEN("DefaultTabstopDistance")},
/* 0132 DISTANCE */                     {MAP_CHAR_LEN("Distance")},
/* 0133 DROP_CAP_FORMAT */              {MAP_CHAR_LEN("DropCapFormat")},
/* 0134 DROP_CAP_WHOLE_WORD */          {MAP_CHAR_LEN("DropCapWholeWord")},
/* 0135 DROP_CAP_CHAR_STYLE_NAME */     {MAP_CHAR_LEN("DropCapCharStyleName")},
/* 0136 FILE_LINK */                    {MAP_CHAR_LEN("FileLink")},
/* 0137 GRAPHIC */                      {MAP_CHAR_LEN("Graphic")},
/* 0138 GRAPHICS */                     {MAP_CHAR_LEN("Graphics")},
/* 0139 IS_PROTECTED */                 {MAP_CHAR_LEN("IsProtected")},
/* 0140 KEY_AS_ENTRY */                 {MAP_CHAR_LEN("KeyAsEntry")},
/* 0141 PARA_KEEP_TOGETHER */           {MAP_CHAR_LEN("ParaKeepTogether")},
/* 0142 KEEP_TOGETHER */                {MAP_CHAR_LEN("KeepTogether")},
/* 0143 IS_LANDSCAPE */                 {MAP_CHAR_LEN("IsLandscape")},
/* 0144 SEPARATOR_TEXT */               {MAP_CHAR_LEN("SeparatorText")},
/* 0145 MARKS */                        {MAP_CHAR_LEN("Marks")},
/* 0146 NUMBER_POSITION */              {MAP_CHAR_LEN("NumberPosition")},
/* 0147 OUTLINES */                     {MAP_CHAR_LEN("Outlines")},
/* 0148 PAGE_STYLE_NAME */              {MAP_CHAR_LEN("PageStyleName")},
/* 0149 PAGE_STYLE_LAYOUT */            {MAP_CHAR_LEN("PageStyleLayout")},
/* 0150 PARA_STYLES */                  {MAP_CHAR_LEN("ParaStyles")},
/* 0151 PARA_ADJUST */                  {MAP_CHAR_LEN("ParaAdjust")},
/* 0152 PARA_REGISTER_MODE_ACTIVE */    {MAP_CHAR_LEN("ParaRegisterModeActive")},
/* 0153 PARA_STYLE_NAME */              {MAP_CHAR_LEN("ParaStyleName")},
/* 0154 PARA_LAST_LINE_ADJUST */        {MAP_CHAR_LEN("ParaLastLineAdjust")},
/* 0155 PARA_LINE_NUMBER_COUNT */       {MAP_CHAR_LEN("ParaLineNumberCount")},
/* 0156 PARA_LINE_NUMBER_START_VALUE */ {MAP_CHAR_LEN("ParaLineNumberStartValue")},
/* 0157 BACK_COLOR */                   {MAP_CHAR_LEN("BackColor")},
/* 0158 PARA_BACK_COLOR */              {MAP_CHAR_LEN("ParaBackColor")},
/* 0159 PARA_WIDOWS */                  {MAP_CHAR_LEN("ParaWidows")},
/* 0160 PARA_ORPHANS */                 {MAP_CHAR_LEN("ParaOrphans")},
/* 0161 PARA_BACK_TRANSPARENT */        {MAP_CHAR_LEN("ParaBackTransparent")},
/* 0162 POSITION_END_OF_DOC */          {MAP_CHAR_LEN("PositionEndOfDoc")},
/* 0163 POSITION_PROTECTED */           {MAP_CHAR_LEN("PositionProtected")},
/* 0164 ALTERNATIVE_TEXT */             {MAP_CHAR_LEN("AlternativeText")},
/* 0165 PRIMARY_KEY */                  {MAP_CHAR_LEN("PrimaryKey")},
/* 0166 PRINT_TABLES */                 {MAP_CHAR_LEN("PrintTables")},
/* 0167 PRINT_GRAPHICS */               {MAP_CHAR_LEN("PrintGraphics")},
/* 0168 PRINT_REVERSED */               {MAP_CHAR_LEN("PrintReversed")},
/* 0169 PRINT_PROSPECT */               {MAP_CHAR_LEN("PrintProspect")},
/* 0170 PRINT_CONTROLS */               {MAP_CHAR_LEN("PrintControls")},
/* 0171 PRINT_DRAWINGS */               {MAP_CHAR_LEN("PrintDrawings")},
/* 0172 PRINT_RIGHT_PAGES */            {MAP_CHAR_LEN("PrintRightPages")},
/* 0173 PRINT_LEFT_PAGES */             {MAP_CHAR_LEN("PrintLeftPages")},
/* 0174 PRINT_BLACK_FONTS */            {MAP_CHAR_LEN("PrintBlackFonts")},
/* 0175 PRINTER_PAPER_TRAY */           {MAP_CHAR_LEN("PrinterPaperTray")},
/* 0176 PRINT_PAGE_BACKGROUND */        {MAP_CHAR_LEN("PrintPageBackground")},
/* 0177 PRINT_ANNOTATION_MODE */        {MAP_CHAR_LEN("PrintAnnotationMode")},
/* 0178 PRINT_FAX_NAME */               {MAP_CHAR_LEN("PrintFaxName")},
/* 0179 PRINT_PAPER_FROM_SETUP */       {MAP_CHAR_LEN("PrintPaperFromSetup")},
/* 0180 REGISTER_MODE_ACTIVE */         {MAP_CHAR_LEN("RegisterModeActive")},
/* 0181 RELATIVE_WIDTH */               {MAP_CHAR_LEN("RelativeWidth")},
/* 0182 RELATIVE_HEIGHT */              {MAP_CHAR_LEN("RelativeHeight")},
/* 0183 REPEAT_HEADLINE */              {MAP_CHAR_LEN("RepeatHeadline")},
/* 0184 SEARCH_STYLES */                {MAP_CHAR_LEN("SearchStyles")},
/* 0185 SEARCH_BACKWARDS */             {MAP_CHAR_LEN("SearchBackwards")},
/* 0186 SEARCH_SIMILARITY */            {MAP_CHAR_LEN("SearchSimilarity")},
/* 0187 SEARCH_IN_SELECTION */          {MAP_CHAR_LEN("SearchInSelection")},
/* 0188 SEARCH_CASE_SENSITIVE */        {MAP_CHAR_LEN("SearchCaseSensitive")},
/* 0189 SEARCH_SIMILARITY_ADD */        {MAP_CHAR_LEN("SearchSimilarityAdd")},
/* 0190 SEARCH_SIMILARITY_RELAX */      {MAP_CHAR_LEN("SearchSimilarityRelax")},
/* 0191 SEARCH_SIMILARITY_REMOVE */     {MAP_CHAR_LEN("SearchSimilarityRemove")},
/* 0192 SEARCH_REGULAR_EXPRESSION */    {MAP_CHAR_LEN("SearchRegularExpression")},
/* 0193 SEARCH_SIMILARITY_EXCHANGE */   {MAP_CHAR_LEN("SearchSimilarityExchange")},
/* 0194 SECONDARY_KEY */                {MAP_CHAR_LEN("SecondaryKey")},
/* 0195 SEPARATOR_INTERVAL */           {MAP_CHAR_LEN("SeparatorInterval")},
/* 0196 SHOW_BREAKS */                  {MAP_CHAR_LEN("ShowBreaks")},
/* 0197 SHOW_SPACES */                  {MAP_CHAR_LEN("ShowSpaces")},
/* 0198 SHOW_TABLES */                  {MAP_CHAR_LEN("ShowTables")},
/* 0199 SHOW_GRAPHICS */                {MAP_CHAR_LEN("ShowGraphics")},

/* 0200 SHOW_DRAWINGS */                {MAP_CHAR_LEN("ShowDrawings")},
/* 0201 SHOW_TABSTOPS */                {MAP_CHAR_LEN("ShowTabstops")},
/* 0202 SHOW_VERT_RULER */              {MAP_CHAR_LEN("ShowVertRuler")},
/* 0203 SHOW_PARA_BREAKS */             {MAP_CHAR_LEN("ShowParaBreaks")},
/* 0204 SHOW_HIDDEN_TEXT */             {MAP_CHAR_LEN("ShowHiddenText")},
/* 0205 SHOW_ANNOTATIONS */             {MAP_CHAR_LEN("ShowAnnotations")},
/* 0206 SHOW_SOFT_HYPHENS */            {MAP_CHAR_LEN("ShowSoftHyphens")},
/* 0207 SHOW_VERT_SCROLL_BAR */         {MAP_CHAR_LEN("ShowVertScrollBar")},
/* 0208 SHOW_HORI_SCROLL_BAR */         {MAP_CHAR_LEN("ShowHoriScrollBar")},
/* 0209 SHOW_FIELD_COMMANDS */          {MAP_CHAR_LEN("ShowFieldCommands")},
/* 0210 SHOW_TEXT_BOUNDARIES */         {MAP_CHAR_LEN("ShowTextBoundaries")},
/* 0211 SHOW_PROTECTED_SPACES */        {MAP_CHAR_LEN("ShowProtectedSpaces")},
/* 0212 SHOW_TABLE_BOUNDARIES */        {MAP_CHAR_LEN("ShowTableBoundaries")},
/* 0213 SHOW_HIDDEN_PARAGRAPHS */       {MAP_CHAR_LEN("ShowHiddenParagraphs")},
/* 0214 SHOW_INDEX_MARK_BACKGROUND */   {MAP_CHAR_LEN("ShowIndexMarkBackground")},
/* 0215 SHOW_FOOTNOTE_BACKGROUND */     {MAP_CHAR_LEN("ShowFootnoteBackground")},
/* 0216 SHOW_TEXT_FIELD_BACKGROUND */   {MAP_CHAR_LEN("ShowTextFieldBackground")},
/* 0217 IS_SYNC_WIDTH_TO_HEIGHT */      {MAP_CHAR_LEN("IsSyncWidthToHeight")},
/* 0218 IS_SYNC_HEIGHT_TO_WIDTH */      {MAP_CHAR_LEN("IsSyncHeightToWidth")},
/* 0219 SIZE_PROTECTED */               {MAP_CHAR_LEN("SizeProtected")},
/* 0220 SMOOTH_SCROLLING */             {MAP_CHAR_LEN("SmoothScrolling")},
/* 0222 TABLES */                       {MAP_CHAR_LEN("Tables")},
/* 0223 TEXT_FRAMES */                  {MAP_CHAR_LEN("TextFrames")},
/* 0224 TEXT_COLUMNS */                 {MAP_CHAR_LEN("TextColumns")},
/* 0225 BACK_TRANSPARENT */             {MAP_CHAR_LEN("BackTransparent")},
/* 0226 USE_PP */                       {MAP_CHAR_LEN("UsePP")},
/* 0227 USER_METRIC */                  {MAP_CHAR_LEN("UserMetric")},
/* 0228 ANCHOR_TYPE */                  {MAP_CHAR_LEN("AnchorType")},
/* 0229 ANCHOR_TYPES */                 {MAP_CHAR_LEN("AnchorTypes")},
/* 0230 ANCHOR_PAGE_NO */               {MAP_CHAR_LEN("AnchorPageNo")},
/* 0231 ANCHOR_FRAME */                 {MAP_CHAR_LEN("AnchorFrame")},
/* 0232 AUTHOR */                       {MAP_CHAR_LEN("Author")},
/* 0233 BREAK_TYPE */                   {MAP_CHAR_LEN("BreakType")},
/* 0234 CHAIN_NEXT_NAME */              {MAP_CHAR_LEN("ChainNextName")},
/* 0235 CHAIN_PREV_NAME */              {MAP_CHAR_LEN("ChainPrevName")},
/* 0236 CHAPTER_FORMAT */               {MAP_CHAR_LEN("ChapterFormat")},
/* 0237 CLIENT_MAP */                   {MAP_CHAR_LEN("ClientMap")},
/* 0238 CONDITION */                    {MAP_CHAR_LEN("Condition")},
/* 0239 CONTENT */                      {MAP_CHAR_LEN("Content")},
/* 0240 CHAR_CONTOURED */               {MAP_CHAR_LEN("CharContoured")},
/* 0241 CONTOUR_OUTSIDE */              {MAP_CHAR_LEN("ContourOutside")},
/* 0242 CONTENT_PROTECTED */            {MAP_CHAR_LEN("ContentProtected")},
/* 0243 COUNT_EMPTY_LINES */            {MAP_CHAR_LEN("CountEmptyLines")},
/* 0244 RESTART_AT_EACH_PAGE */         {MAP_CHAR_LEN("RestartAtEachPage")},
/* 0245 DATA_BASE_NAME */               {MAP_CHAR_LEN("DataBaseName")},
/* 0246 DATA_TABLE_NAME */              {MAP_CHAR_LEN("DataTableName")},
/* 0247 DATA_COMMAND_TYPE */            {MAP_CHAR_LEN("DataCommandType")},
/* 0248 DATA_COLUMN_NAME */             {MAP_CHAR_LEN("DataColumnName")},
/* 0249 IS_DATA_BASE_FORMAT */          {MAP_CHAR_LEN("DataBaseFormat")},
/* 0250 DATE */                         {MAP_CHAR_LEN("Date")},
/* 0251 IS_DATE */                      {MAP_CHAR_LEN("IsDate")},
/* 0252 EDIT_IN_READONLY */             {MAP_CHAR_LEN("EditInReadonly")},
/* 0253 FALSE_CONTENT */                {MAP_CHAR_LEN("FalseContent")},
/* 0254 FILE_FORMAT */                  {MAP_CHAR_LEN("FileFormat")},
/* 0255 IS_FIXED */                     {MAP_CHAR_LEN("IsFixed")},
/* 0256 FOOTNOTE_COUNTING */            {MAP_CHAR_LEN("FootnoteCounting")},
/* 0257 FORMULA */                      {MAP_CHAR_LEN("Formula")},
/* 0258 FRAME_NAME */                   {MAP_CHAR_LEN("FrameName")},
/* 0259 GRAPHIC_NAME */                 {MAP_CHAR_LEN("GraphicName")},
/* 0260 FULL_NAME */                    {MAP_CHAR_LEN("FullName")},
/* 0261 HEIGHT */                       {MAP_CHAR_LEN("Height")},
/* 0262 IS_AUTO_HEIGHT */               {MAP_CHAR_LEN("IsAutoHeight")},
/* 0263 SIZE_TYPE */                    {MAP_CHAR_LEN("SizeType")},
/* 0264 HINT */                         {MAP_CHAR_LEN("Hint")},
/* 0265 HORI_ORIENT */                  {MAP_CHAR_LEN("HoriOrient")},
/* 0266 HORI_MIRRORED_ON_EVEN_PAGES */  {MAP_CHAR_LEN("HoriMirroredOnEvenPages")},
/* 0267 HORI_MIRRORED_ON_ODD_PAGES */   {MAP_CHAR_LEN("HoriMirroredOnOddPages")},
/* 0268 HORI_ORIENT_RELATION */         {MAP_CHAR_LEN("HoriOrientRelation")},
/* 0269 HORI_ORIENT_POSITION */         {MAP_CHAR_LEN("HoriOrientPosition")},
/* 0270 HYPER_LINK_U_R_L */             {MAP_CHAR_LEN("HyperLinkURL")},
/* 0271 HYPER_LINK_TARGET */            {MAP_CHAR_LEN("HyperLinkTarget")},
/* 0272 HYPER_LINK_NAME */              {MAP_CHAR_LEN("HyperLinkName")},
/* 0273 HYPER_LINK_EVENTS */            {MAP_CHAR_LEN("HyperLinkEvents")},
/* 0274 INFO_TYPE */                    {MAP_CHAR_LEN("InfoType")},
/* 0275 INFO_FORMAT */                  {MAP_CHAR_LEN("InfoFormat")},
/* 0276 IS_INPUT */                     {MAP_CHAR_LEN("Input")},
/* 0277 LEVEL */                        {MAP_CHAR_LEN("Level")},
/* 0278 INTERVAL */                     {MAP_CHAR_LEN("Interval")},
/* 0279 LINK_REGION */                  {MAP_CHAR_LEN("LinkRegion")},
/* 0280 MACRO_NAME */                   {MAP_CHAR_LEN("MacroName")},
/* 0281 SPLIT */                        {MAP_CHAR_LEN("Split")},
/* 0282 PARA_SPLIT */                   {MAP_CHAR_LEN("ParaSplit")},
/* 0283 NUMBER_FORMAT */                {MAP_CHAR_LEN("NumberFormat")},
/* 0284 NUMBERING_TYPE */               {MAP_CHAR_LEN("NumberingType")},
/* 0285 NUMBERING_RULES */              {MAP_CHAR_LEN("NumberingRules")},
/* 0286 OFFSET */                       {MAP_CHAR_LEN("Offset")},
/* 0287 ON */                           {MAP_CHAR_LEN("On")},
/* 0288 OPAQUE */                       {MAP_CHAR_LEN("Opaque")},
/* 0289 PAGE_TOGGLE */                  {MAP_CHAR_LEN("PageToggle")},
/* 0290 PAGE_DESC_NAME */               {MAP_CHAR_LEN("PageDescName")},
/* 0291 PAGE_NUMBER_OFFSET */           {MAP_CHAR_LEN("PageNumberOffset")},
/* 0292 PLACEHOLDER */                  {MAP_CHAR_LEN("PlaceHolder")},
/* 0293 PLACEHOLDER_TYPE */             {MAP_CHAR_LEN("PlaceHolderType")},
/* 0294 PRINT */                        {MAP_CHAR_LEN("Print")},
/* 0295 REFERENCE_FIELD_PART */         {MAP_CHAR_LEN("ReferenceFieldPart")},
/* 0296 REFERENCE_FIELD_SOURCE */       {MAP_CHAR_LEN("ReferenceFieldSource")},
/* 0297 REGISTER_PARAGRAPH_STYLE */     {MAP_CHAR_LEN("RegisterParagraphStyle")},
/* 0298 SCRIPT_TYPE */                  {MAP_CHAR_LEN("ScriptType")},
/* 0299 SEARCH_ALL */                   {MAP_CHAR_LEN("SearchAll")},

/* 0300 SEARCH_WORDS */                 {MAP_CHAR_LEN("SearchWords")},
/* 0301 SEQUENCE_VALUE */               {MAP_CHAR_LEN("SequenceValue")},
/* 0302 SERVER_MAP */                   {MAP_CHAR_LEN("ServerMap")},
/* 0303 IMAGE_MAP */                    {MAP_CHAR_LEN("ImageMap")},
/* 0304 SET_NUMBER */                   {MAP_CHAR_LEN("SetNumber")},
/* 0305 SHADOW_FORMAT */                {MAP_CHAR_LEN("ShadowFormat")},
/* 0306 SHOW_HORI_RULER */              {MAP_CHAR_LEN("ShowHoriRuler")},
/* 0307 SIZE */                         {MAP_CHAR_LEN("Size")},
/* 0308 ACTUAL_SIZE */                  {MAP_CHAR_LEN("ActualSize")},
/* 0309 SOURCE_NAME */                  {MAP_CHAR_LEN("SourceName")},
/* 0310 START_AT */                     {MAP_CHAR_LEN("StartAt")},
/* 0311 STATISTIC_TYPE_ID */            {MAP_CHAR_LEN("StatisticTypeId")},
/* 0312 SUB_TYPE */                     {MAP_CHAR_LEN("SubType")},
/* 0313 SURROUND */                     {MAP_CHAR_LEN("Surround")},
/* 0314 IS_EXPRESSION */                {MAP_CHAR_LEN("IsExpression")},
/* 0315 IS_SHOW_FORMULA */              {MAP_CHAR_LEN("IsShowFormula")},
/* 0316 TEXT_WRAP */                    {MAP_CHAR_LEN("TextWrap")},
/* 0317 SURROUND_CONTOUR */             {MAP_CHAR_LEN("SurroundContour")},
/* 0318 SURROUND_ANCHORONLY */          {MAP_CHAR_LEN("SurroundAnchorOnly")},
/* 0319 TABLE_NAME */                   {MAP_CHAR_LEN("TableName")},
/* 0320 TABSTOPS */                     {MAP_CHAR_LEN("ParaTabStops")},
/* 0321 TITLE */                        {MAP_CHAR_LEN("Title")},
/* 0322 TOP_MARGIN */                   {MAP_CHAR_LEN("TopMargin")},
/* 0323 BOTTOM_MARGIN */                {MAP_CHAR_LEN("BottomMargin")},
/* 0324 TRUE_CONTENT */                 {MAP_CHAR_LEN("TrueContent")},
/* 0325 URL_CONTENT */                  {MAP_CHAR_LEN("URLContent")},
/* 0326 USERTEXT */                     {MAP_CHAR_LEN("UserText")},
/* 0327 USER_DATA_TYPE */               {MAP_CHAR_LEN("UserDataType")},
/* 0328 VALUE */                        {MAP_CHAR_LEN("Value")},
/* 0329 VARIABLE_NAME */                {MAP_CHAR_LEN("VariableName")},
/* 0330 VARIABLE_SUBTYPE */             {MAP_CHAR_LEN("VariableSubtype")},
/* 0331 VERT_ORIENT */                  {MAP_CHAR_LEN("VertOrient")},
/* 0332 VERT_MIRRORED */                {MAP_CHAR_LEN("VertMirrored")},
/* 0333 VERT_ORIENT_POSITION */         {MAP_CHAR_LEN("VertOrientPosition")},
/* 0334 VERT_ORIENT_RELATION */         {MAP_CHAR_LEN("VertOrientRelation")},
/* 0335 IS_VISIBLE */                   {MAP_CHAR_LEN("IsVisible")},
/* 0336 WIDTH */                        {MAP_CHAR_LEN("Width")},
/* 0337 CHAR_WORD_MODE */               {MAP_CHAR_LEN("CharWordMode")},
/* 0338 GRAPHIC_CROP */                 {MAP_CHAR_LEN("GraphicCrop")},
/* 0339 CHARACTER_FORMAT_NONE */        {MAP_CHAR_LEN("CharacterFormatNone")},
/* 0340 TEXT_POSITION */                {MAP_CHAR_LEN("TextPosition")},
/* 0341 DOCUMENT_INDEX_MARK */          {MAP_CHAR_LEN("DocumentIndexMark")},
/* 0342 DOCUMENT_INDEX */               {MAP_CHAR_LEN("DocumentIndex")},
/* 0343 IS_GLOBAL_DOCUMENT_SECTION */   {MAP_CHAR_LEN("IsGlobalDocumentSection")},
/* 0344 TEXT_FIELD */                   {MAP_CHAR_LEN("TextField")},
/* 0345 BOOKMARK */                     {MAP_CHAR_LEN("Bookmark")},
/* 0346 TEXT_TABLE */                   {MAP_CHAR_LEN("TextTable")},
/* 0347 CELL */                         {MAP_CHAR_LEN("Cell")},
/* 0348 TEXT_FRAME */                   {MAP_CHAR_LEN("TextFrame")},
/* 0349 REFERENCE_MARK */               {MAP_CHAR_LEN("ReferenceMark")},
/* 0350 TEXT_SECTION */                 {MAP_CHAR_LEN("TextSection")},
/* 0351 FOOTNOTE */                     {MAP_CHAR_LEN("Footnote")},
/* 0352 ENDNOTE */                      {MAP_CHAR_LEN("Endnote")},
/* 0353 CHART_ROW_AS_LABEL */           {MAP_CHAR_LEN("ChartRowAsLabel")},
/* 0354 CHART_COLUMN_AS_LABEL */        {MAP_CHAR_LEN("ChartColumnAsLabel")},
/* 0355 TABLE_COLUMS */                 {MAP_CHAR_LEN("TableColumns")},
/* 0356 LEFT_BORDER */                  {MAP_CHAR_LEN("LeftBorder")},
/* 0357 RIGHT_BORDER */                 {MAP_CHAR_LEN("RightBorder")},
/* 0358 TOP_BORDER */                   {MAP_CHAR_LEN("TopBorder")},
/* 0359 BOTTOM_BORDER */                {MAP_CHAR_LEN("BottomBorder")},
/* 0360 BORDER_DISTANCE */              {MAP_CHAR_LEN("BorderDistance")},
/* 0361 LEFT_BORDER_DISTANCE */         {MAP_CHAR_LEN("LeftBorderDistance")},
/* 0362 RIGHT_BORDER_DISTANCE */        {MAP_CHAR_LEN("RightBorderDistance")},
/* 0363 TOP_BORDER_DISTANCE */          {MAP_CHAR_LEN("TopBorderDistance")},
/* 0364 BOTTOM_BORDER_DISTANCE */       {MAP_CHAR_LEN("BottomBorderDistance")},
/* 0365 TABLE_BORDER */                 {MAP_CHAR_LEN("TableBorder")},
/* 0366 TABLE_COLUMN_SEPARATORS */      {MAP_CHAR_LEN("TableColumnSeparators")},
/* 0367 TABLE_COLUMN_RELATIVE_SUM */    {MAP_CHAR_LEN("TableColumnRelativeSum")},
/* 0368 HEADER_TEXT */                  {MAP_CHAR_LEN("HeaderText")},
/* 0369 HEADER_TEXT_LEFT */             {MAP_CHAR_LEN("HeaderTextLeft")},
/* 0370 HEADER_TEXT_RIGHT */            {MAP_CHAR_LEN("HeaderTextRight")},
/* 0371 FOOTER_TEXT */                  {MAP_CHAR_LEN("FooterText")},
/* 0372 FOOTER_TEXT_LEFT */             {MAP_CHAR_LEN("FooterTextLeft")},
/* 0373 FOOTER_TEXT_RIGHT */            {MAP_CHAR_LEN("FooterTextRight")},
/* 0374 HEADER_BACK_COLOR */            {MAP_CHAR_LEN("HeaderBackColor")},
/* 0375 HEADER_GRAPHIC */               {MAP_CHAR_LEN("HeaderBackGraphic")},
/* 0376 HEADER_BACK_TRANSPARENT */      {MAP_CHAR_LEN("HeaderBackTransparent")},
/* 0377 HEADER_LEFT_BORDER */           {MAP_CHAR_LEN("HeaderLeftBorder")},
/* 0378 HEADER_RIGHT_BORDER */          {MAP_CHAR_LEN("HeaderRightBorder")},
/* 0379 HEADER_TOP_BORDER */            {MAP_CHAR_LEN("HeaderTopBorder")},
/* 0380 HEADER_BOTTOM_BORDER */         {MAP_CHAR_LEN("HeaderBottomBorder")},
/* 0381 HEADER_BORDER_DISTANCE */       {MAP_CHAR_LEN("HeaderBorderDistance")},
/* 0382 HEADER_SHADOW_FORMAT */         {MAP_CHAR_LEN("HeaderShadowFormat")},
/* 0383 HEADER_BODY_DISTANCE */         {MAP_CHAR_LEN("HeaderBodyDistance")},
/* 0384 HEADER_IS_DYNAMIC_HEIGHT */     {MAP_CHAR_LEN("HeaderIsDynamicHeight")},
/* 0385 HEADER_IS_SHARED */             {MAP_CHAR_LEN("HeaderIsShared")},
/* 0386 HEADER_HEIGHT */                {MAP_CHAR_LEN("HeaderHeight")},
/* 0387 HEADER_IS_ON */                 {MAP_CHAR_LEN("HeaderIsOn")},
/* 0388 FOOTER_BACK_COLOR */            {MAP_CHAR_LEN("FooterBackColor")},
/* 0389 FOOTER_GRAPHIC */               {MAP_CHAR_LEN("FooterBackGraphic")},
/* 0390 FOOTER_BACK_TRANSPARENT */      {MAP_CHAR_LEN("FooterBackTransparent")},
/* 0391 FOOTER_LEFT_BORDER */           {MAP_CHAR_LEN("FooterLeftBorder")},
/* 0392 FOOTER_RIGHT_BORDER */          {MAP_CHAR_LEN("FooterRightBorder")},
/* 0393 FOOTER_TOP_BORDER */            {MAP_CHAR_LEN("FooterTopBorder")},
/* 0394 FOOTER_BOTTOM_BORDER */         {MAP_CHAR_LEN("FooterBottomBorder")},
/* 0395 FOOTER_BORDER_DISTANCE */       {MAP_CHAR_LEN("FooterBorderDistance")},
/* 0396 FOOTER_SHADOW_FORMAT */         {MAP_CHAR_LEN("FooterShadowFormat")},
/* 0397 FOOTER_BODY_DISTANCE */         {MAP_CHAR_LEN("FooterBodyDistance")},
/* 0398 FOOTER_IS_DYNAMIC_HEIGHT */     {MAP_CHAR_LEN("FooterIsDynamicHeight")},
/* 0399 FOOTER_IS_SHARED */             {MAP_CHAR_LEN("FooterIsShared")},

/* 0400 FOOTER_HEIGHT */                {MAP_CHAR_LEN("FooterHeight")},
/* 0401 FOOTER_IS_ON */                 {MAP_CHAR_LEN("FooterIsOn")},
/* 0402 OVERWRITE_STYLES */             {MAP_CHAR_LEN("OverwriteStyles")},
/* 0403 LOAD_NUMBERING_STYLES */        {MAP_CHAR_LEN("LoadNumberingStyles")},
/* 0404 LOAD_PAGE_STYLES */             {MAP_CHAR_LEN("LoadPageStyles")},
/* 0405 LOAD_FRAME_STYLES */            {MAP_CHAR_LEN("LoadFrameStyles")},
/* 0406 LOAD_TEXT_STYLES */             {MAP_CHAR_LEN("LoadTextStyles")},
/* 0407 FILE_NAME */                    {MAP_CHAR_LEN("FileName")},
/* 0408 FILTER_NAME */                  {MAP_CHAR_LEN("FilterName")},
/* 0409 FILTER_OPTION */                {MAP_CHAR_LEN("FilterOption")},
/* 0410 PASSWORD */                     {MAP_CHAR_LEN("Password")},
/* 0411 COPY_COUNT */                   {MAP_CHAR_LEN("CopyCount")},
/* 0412 COLLATE */                      {MAP_CHAR_LEN("Collate")},
/* 0413 SORT */                         {MAP_CHAR_LEN("Sort")},
/* 0414 PAGES */                        {MAP_CHAR_LEN("Pages")},
/* 0415 FIRST_LINE_OFFSET */            {MAP_CHAR_LEN("FirstLineOffset")},
/* 0416 SYMBOL_TEXT_DISTANCE */         {MAP_CHAR_LEN("SymbolTextDistance")},
/* 0417 USER_INDEX_NAME */              {MAP_CHAR_LEN("UserIndexName")},
/* 0418 REVISION */                     {MAP_CHAR_LEN("Revision")},
/* 0419 UNVISITED_CHAR_STYLE_NAME */    {MAP_CHAR_LEN("UnvisitedCharStyleName")},
/* 0420 VISITED_CHAR_STYLE_NAME */      {MAP_CHAR_LEN("VisitedCharStyleName")},
/* 0421 PARAGRAPH_COUNT */              {MAP_CHAR_LEN("ParagraphCount")},
/* 0422 WORD_COUNT */                   {MAP_CHAR_LEN("WordCount")},
/* 0423 WORD_SEPARATOR */               {MAP_CHAR_LEN("WordSeparator")},
/* 0424 CHARACTER_COUNT */              {MAP_CHAR_LEN("CharacterCount")},
/* 0425 ZOOM_VALUE */                   {MAP_CHAR_LEN("ZoomValue")},
/* 0426 ZOOM_TYPE */                    {MAP_CHAR_LEN("ZoomType")},
/* 0427 CREATE_FROM_MARKS */            {MAP_CHAR_LEN("CreateFromMarks")},
/* 0428 CREATE_FROM_OUTLINE */          {MAP_CHAR_LEN("CreateFromOutline")},
/* 0429 PARAGRAPH_STYLE_NAMES */        {MAP_CHAR_LEN("ParagraphStyleNames")},
/* 0430 CREATE_FROM_CHAPTER */          {MAP_CHAR_LEN("CreateFromChapter")},
/* 0431 CREATE_FROM_LABELS */           {MAP_CHAR_LEN("CreateFromLabels")},
/* 0432 USE_ALPHABETICAL_SEPARATORS */  {MAP_CHAR_LEN("UseAlphabeticalSeparators")},
/* 0433 USE_KEY_AS_ENTRY */             {MAP_CHAR_LEN("UseKeyAsEntry")},
/* 0434 USE_COMBINED_ENTRIES */         {MAP_CHAR_LEN("UseCombinedEntries")},
/* 0435 IS_CASE_SENSITIVE */            {MAP_CHAR_LEN("IsCaseSensitive")},
/* 0436 USE_P_P */                      {MAP_CHAR_LEN("UsePP")},
/* 0437 USE_DASH */                     {MAP_CHAR_LEN("UseDash")},
/* 0438 USE_UPPER_CASE */               {MAP_CHAR_LEN("UseUpperCase")},
/* 0439 LABEL_CATEGORY */               {MAP_CHAR_LEN("LabelCategory")},
/* 0440 LABEL_DISPLAY_TYPE */           {MAP_CHAR_LEN("LabelDisplayType")},
/* 0441 USE_LEVEL_FROM_SOURCE */        {MAP_CHAR_LEN("UseLevelFromSource")},
/* 0442 LEVEL_FORMAT */                 {MAP_CHAR_LEN("LevelFormat")},
/* 0443 LEVEL_PARAGRAPH_STYLES */       {MAP_CHAR_LEN("LevelParagraphStyles")},
/* 0444 RECALC_TAB_STOPS */             {MAP_CHAR_LEN("RecalcTabStops")},
/* 0445 MAIN_ENTRY_CHARACTER_STYLE_NAME */  {MAP_CHAR_LEN("MainEntryCharacterStyleName")},
/* 0446 CREATE_FROM_TABLES */           {MAP_CHAR_LEN("CreateFromTables")},
/* 0447 CREATE_FROM_TEXT_FRAMES */      {MAP_CHAR_LEN("CreateFromTextFrames")},
/* 0448 CREATE_FROM_GRAPHIC_OBJECTS */  {MAP_CHAR_LEN("CreateFromGraphicObjects")},
/* 0449 CREATE_FROM_EMBEDDED_OBJECTS */ {MAP_CHAR_LEN("CreateFromEmbeddedObjects")},
/* 0450 CREATE_FROM_STAR_MATH */        {MAP_CHAR_LEN("CreateFromStarMath")},
/* 0451 CREATE_FROM_STAR_CHART */       {MAP_CHAR_LEN("CreateFromStarChart")},
/* 0452 CREATE_FROM_STAR_CALC */        {MAP_CHAR_LEN("CreateFromStarCalc")},
/* 0453 CREATE_FROM_STAR_DRAW */        {MAP_CHAR_LEN("CreateFromStarDraw")},
/* 0454 CREATE_FROM_OTHER_EMBEDDED_OBJECTS */   {MAP_CHAR_LEN("CreateFromOtherEmbeddedObjects")},
/* 0455 INDEX_AUTO_MARK_FILE_U_R_L */   {MAP_CHAR_LEN("IndexAutoMarkFileURL")},
/* 0456 IS_COMMA_SEPARATED */           {MAP_CHAR_LEN("IsCommaSeparated")},
/* 0457 IS_RELATIVE_TABSTOPS */         {MAP_CHAR_LEN("IsRelativeTabstops")},
/* 0458 CREATE_FROM_LEVEL_PARAGRAPH_STYLES */                       {MAP_CHAR_LEN("CreateFromLevelParagraphStyles")},
/* 0459 SHOW_CHANGES */                 {MAP_CHAR_LEN("ShowChanges")},
/* 0460 RECORD_CHANGES */               {MAP_CHAR_LEN("RecordChanges")},
/* 0461 DISPLAY_NAME */                 {MAP_CHAR_LEN("LinkDisplayName")},
/* 0462 DISPLAY_BITMAP */               {MAP_CHAR_LEN("LinkDisplayBitmap")},
/* 0463 HEADING_STYLE_NAME */           {MAP_CHAR_LEN("HeadingStyleName")},
/* 0464 SHOW_ONLINE_LAYOUT */           {MAP_CHAR_LEN("ShowOnlineLayout")},
/* 0465 USER_DEFINED_ATTRIBUTES */      {MAP_CHAR_LEN("UserDefinedAttributes")},
/* 0466 TEXT_USER_DEFINED_ATTRIBUTES */ {MAP_CHAR_LEN("TextUserDefinedAttributes")},
/* 0467 FILE_PATH */                    {MAP_CHAR_LEN("FilePath")},
/* 0468 PARA_CHAPTER_NUMBERING_LEVEL */ {MAP_CHAR_LEN("ParaChapterNumberingLevel")},
/* 0469 PARA_CONDITIONAL_STYLE_NAME */  {MAP_CHAR_LEN("ParaConditionalStyleName")},
/* 0470 CHAPTER_NUMBERING_LEVEL */      {MAP_CHAR_LEN("ChapterNumberingLevel")},
/* 0471 NUMBERING_SEPARATOR */          {MAP_CHAR_LEN("NumberingSeparator")},
/* 0472 IS_CONTINUOUS_NUMBERING */      {MAP_CHAR_LEN("IsContinuousNumbering")},
/* 0473 IS_AUTOMATIC */                 {MAP_CHAR_LEN("IsAutomatic")},
/* 0474 IS_ABSOLUTE_MARGINS */          {MAP_CHAR_LEN("IsAbsoluteMargins")},
/* 0475 CATEGORY */                     {MAP_CHAR_LEN("Category")},
/* 0476 DEPENDENT_TEXT_FIELDS */        {MAP_CHAR_LEN("DependentTextFields")},
/* 0477 CURRENT_PRESENTATION */         {MAP_CHAR_LEN("CurrentPresentation")},
/* 0478 ADJUST */                       {MAP_CHAR_LEN("Adjust")},
/* 0479 INSTANCE_NAME */                {MAP_CHAR_LEN("InstanceName")},
/* 0480 TEXT_PORTION_TYPE */            {MAP_CHAR_LEN("TextPortionType")},
/* 0481 CONTROL_CHARACTER */            {MAP_CHAR_LEN("ControlCharacter")},
/* 0482 IS_COLLAPSED */                 {MAP_CHAR_LEN("IsCollapsed")},
/* 0483 IS_START */                     {MAP_CHAR_LEN("IsStart")},
/* 0484 SEQUENCE_NUMBER */              {MAP_CHAR_LEN("SequenceNumber")},
/* 0485 REFERENCE_ID */                 {MAP_CHAR_LEN("ReferenceId")},
/* 0486 HEADER_LEFT_BORDER_DISTANCE */  {MAP_CHAR_LEN("HeaderLeftBorderDistance")},
/* 0487 HEADER_RIGHT_BORDER_DISTANCE */ {MAP_CHAR_LEN("HeaderRightBorderDistance")},
/* 0488 HEADER_TOP_BORDER_DISTANCE */   {MAP_CHAR_LEN("HeaderTopBorderDistance")},
/* 0489 HEADER_BOTTOM_BORDER_DISTANCE */{MAP_CHAR_LEN("HeaderBottomBorderDistance")},
/* 0490 FOOTER_LEFT_BORDER_DISTANCE */  {MAP_CHAR_LEN("FooterLeftBorderDistance")},
/* 0491 FOOTER_RIGHT_BORDER_DISTANCE */ {MAP_CHAR_LEN("FooterRightBorderDistance")},
/* 0492 FOOTER_TOP_BORDER_DISTANCE */   {MAP_CHAR_LEN("FooterTopBorderDistance")},
/* 0493 FOOTER_BOTTOM_BORDER_DISTANCE */{MAP_CHAR_LEN("FooterBottomBorderDistance")},
/* 0494 PARA_IS_NUMBERING_RESTART */    {MAP_CHAR_LEN("ParaIsNumberingRestart")},
/* 0495 HIDE_FIELD_TIPS */              {MAP_CHAR_LEN("HideFieldTips")},
/* 0496 HEADER_USER_DEFINED_ATTRIBUTES */   {MAP_CHAR_LEN("HeaderUserDefinedAttributes")},
/* 0497 FOOTER_USER_DEFINED_ATTRIBUTES */   {MAP_CHAR_LEN("FooterUserDefinedAttributes")},
/* 0498 PARA_SHADOW_FORMAT */           {MAP_CHAR_LEN("ParaShadowFormat")},
/* 0499 CONTOUR_POLY_POLYGON */         {MAP_CHAR_LEN("ContourPolyPolygon")},

/* 0500 IS_PIXEL_CONTOUR */             {MAP_CHAR_LEN("IsPixelContour")},
/* 0501 IS_AUTOMATIC_CONTOUR */         {MAP_CHAR_LEN("IsAutomaticContour")},
/* 0502 SEPARATOR_LINE_WIDTH */         {MAP_CHAR_LEN("SeparatorLineWidth")},
/* 0503 SEPARATOR_LINE_COLOR */         {MAP_CHAR_LEN("SeparatorLineColor")},
/* 0504 SEPARATOR_LINE_RELATIVE_HEIGHT */   {MAP_CHAR_LEN("SeparatorLineRelativeHeight")},
/* 0505 SEPARATOR_LINE_VERTIVAL_ALIGNMENT */{MAP_CHAR_LEN("SeparatorLineVerticalAlignment")},
/* 0506 SEPARATOR_LINE_IS_ON */         {MAP_CHAR_LEN("SeparatorLineIsOn")},
/* 0507 IS_SKIP_HIDDEN_TEXT */          {MAP_CHAR_LEN("IsSkipHiddenText")},
/* 0508 IS_SKIP_PROTECTED_TEXT */       {MAP_CHAR_LEN("IsSkipProtectedText")},
/* 0509 DOCUMENT_INDEX_MARKS */         {MAP_CHAR_LEN("DocumentIndexMarks")},
/* 0510 FOOTNOTE_IS_COLLECT_AT_TEXT_END */  {MAP_CHAR_LEN("FootnoteIsCollectAtTextEnd")},
/* 0511 FOOTNOTE_IS_RESTART_NUMBERING */    {MAP_CHAR_LEN("FootnoteIsRestartNumbering")},
/* 0512 FOOTNOTE_RESTART_NUMBERING_AT */{MAP_CHAR_LEN("FootnoteRestartNumberingAt")},
/* 0513 FOOTNOTE_IS_OWN_NUMBERING */    {MAP_CHAR_LEN("FootnoteIsOwnNumbering")},
/* 0514 FOOTNOTE_NUMBERING_TYPE */      {MAP_CHAR_LEN("FootnoteNumberingType")},
/* 0515 FOOTNOTE_NUMBERING_PREFIX */    {MAP_CHAR_LEN("FootnoteNumberingPrefix")},
/* 0516 FOOTNOTE_NUMBERING_SUFFIX */    {MAP_CHAR_LEN("FootnoteNumberingSuffix")},
/* 0517 ENDNOTE_IS_COLLECT_AT_TEXT_END */   {MAP_CHAR_LEN("EndnoteIsCollectAtTextEnd")},
/* 0518 ENDNOTE_IS_RESTART_NUMBERING */ {MAP_CHAR_LEN("EndnoteIsRestartNumbering")},
/* 0519 ENDNOTE_RESTART_NUMBERING_AT */ {MAP_CHAR_LEN("EndnoteRestartNumberingAt")},
/* 0520 ENDNOTE_IS_OWN_NUMBERING */     {MAP_CHAR_LEN("EndnoteIsOwnNumbering")},
/* 0521 ENDNOTE_NUMBERING_TYPE */       {MAP_CHAR_LEN("EndnoteNumberingType")},
/* 0522 ENDNOTE_NUMBERING_PREFIX */     {MAP_CHAR_LEN("EndnoteNumberingPrefix")},
/* 0523 ENDNOTE_NUMBERING_SUFFIX */     {MAP_CHAR_LEN("EndnoteNumberingSuffix")},
/* 0524 BRACKET_BEFORE */               {MAP_CHAR_LEN("BracketBefore")},
/* 0525 BRACKET_AFTER */                {MAP_CHAR_LEN("BracketAfter")},
/* 0526 IS_NUMBER_ENTRIES */            {MAP_CHAR_LEN("IsNumberEntries")},
/* 0527 IS_SORT_BY_POSITION */          {MAP_CHAR_LEN("IsSortByPosition")},
/* 0528 SORT_KEYS */                    {MAP_CHAR_LEN("SortKeys")},
/* 0529 IS_SORT_ASCENDING */            {MAP_CHAR_LEN("IsSortAscending")},
/* 0530 SORT_KEY */                     {MAP_CHAR_LEN("SortKey")},
/* 0531 FIELDS */                       {MAP_CHAR_LEN("Fields")},
/* 0532 DATE_TIME_VALUE */              {MAP_CHAR_LEN("DateTimeValue")},
/* 0533 IS_ON */                        {MAP_CHAR_LEN("IsOn")},
/* 0534 Z_ORDER */                      {MAP_CHAR_LEN("ZOrder")},
/* 0535 CONTENT_SECTION */              {MAP_CHAR_LEN("ContentSection")},
/* 0536 HEADER_SECTION */               {MAP_CHAR_LEN("HeaderSection")},
/* 0537 PARA_IS_HANGING_PUNCTUATION */  {MAP_CHAR_LEN("ParaIsHangingPunctuation")},
/* 0538 PARA_IS_CHARACTER_DISTANCE */   {MAP_CHAR_LEN("ParaIsCharacterDistance")},
/* 0539 PARA_IS_FORBIDDEN_RULES */      {MAP_CHAR_LEN("ParaIsForbiddenRules")},
/* 0540 PARA_VERT_ALIGNMENT */          {MAP_CHAR_LEN("ParaVertAlignment")},
/* 0541 IS_MAIN_ENTRY */                {MAP_CHAR_LEN("IsMainEntry")},
/* 0542 GRAPHIC_ROTATION */             {MAP_CHAR_LEN("GraphicRotation")},
/* 0543 ADJUST_LUMINANCE */             {MAP_CHAR_LEN("AdjustLuminance")},
/* 0544 ADJUST_CONTRAST */              {MAP_CHAR_LEN("AdjustContrast")},
/* 0545 ADJUST_RED */                   {MAP_CHAR_LEN("AdjustRed")},
/* 0546 ADJUST_GREEN */                 {MAP_CHAR_LEN("AdjustGreen")},
/* 0547 ADJUST_BLUE */                  {MAP_CHAR_LEN("AdjustBlue")},
/* 0548 GAMMA */                        {MAP_CHAR_LEN("Gamma")},
/* 0549 GRAPHIC_IS_INVERTED */          {MAP_CHAR_LEN("GraphicIsInverted")},
/* 0550 TRANSPARENCY */                 {MAP_CHAR_LEN("Transparency")},
/* 0551 GRAPHIC_COLOR_MODE */           {MAP_CHAR_LEN("GraphicColorMode")},
/* 0552 REDLINE_AUTHOR */               {MAP_CHAR_LEN("RedlineAuthor")},
/* 0553 REDLINE_DATE_TIME */            {MAP_CHAR_LEN("RedlineDateTime")},
/* 0554 REDLINE_COMMENT */              {MAP_CHAR_LEN("RedlineComment")},
/* 0555 REDLINE_TYPE */                 {MAP_CHAR_LEN("RedlineType")},
/* 0556 REDLINE_SUCCESSOR_DATA */       {MAP_CHAR_LEN("RedlineSuccessorData")},
/* 0557 REDLINE_IDENTIFIER */           {MAP_CHAR_LEN("RedlineIdentifier")},
/* 0558 IS_IN_HEADER_FOOTER */          {MAP_CHAR_LEN("IsInHeaderFooter")},
/* 0559 START_REDLINE */                {MAP_CHAR_LEN("StartRedline")},
/* 0560 END_REDLINE */                  {MAP_CHAR_LEN("EndRedline")},
/* 0561 REDLINE_START */                {MAP_CHAR_LEN("RedlineStart")},
/* 0562 REDLINE_END */                  {MAP_CHAR_LEN("RedlineEnd")},
/* 0563 REDLINE_TEXT */                 {MAP_CHAR_LEN("RedlineText")},
/* 0564 REDLINE_DISPLAY_TYPE */         {MAP_CHAR_LEN("RedlineDisplayType")},
/* 0565 FORBIDDEN_CHARACTERS */         {MAP_CHAR_LEN("ForbiddenCharacters")},
/* 0566 RUBY_BASE_TEXT */               {MAP_CHAR_LEN("RubyBaseText")},
/* 0567 RUBY_TEXT */                    {MAP_CHAR_LEN("RubyText")},
/* 0568 RUBY_ADJUST */                  {MAP_CHAR_LEN("RubyAdjust")},
/* 0569 RUBY_CHAR_STYLE_NAME */         {MAP_CHAR_LEN("RubyCharStyleName")},
/* 0570 RUBY_IS_ABOVE */                {MAP_CHAR_LEN("RubyIsAbove")},
/* 0571 FOOTNOTE_HEIGHT */              {MAP_CHAR_LEN("FootnoteHeight")},
/* 0572 FOOTNOTE_LINE_WEIGHT */         {MAP_CHAR_LEN("FootnoteLineWeight")},
/* 0573 FOOTNOTE_LINE_COLOR */          {MAP_CHAR_LEN("FootnoteLineColor")},
/* 0574 FOOTNOTE_LINE_RELATIVE_WIDTH */ {MAP_CHAR_LEN("FootnoteLineRelativeWidth")},
/* 0575 FOOTNOTE_LINE_ADJUST */         {MAP_CHAR_LEN("FootnoteLineAdjust")},
/* 0576 FOOTNOTE_LINE_TEXT_DISTANCE */  {MAP_CHAR_LEN("FootnoteLineTextDistance")},
/* 0577 FOOTNOTE_LINE_DISTANCE */       {MAP_CHAR_LEN("FootnoteLineDistance")},
/* 0578 CHAR_ROTATION */                {MAP_CHAR_LEN("CharRotation")},
/* 0579 CHAR_ROTATION_IS_FIT_TO_LINE */ {MAP_CHAR_LEN("CharRotationIsFitToLine")},
/* 0580 CHAR_SCALE_WIDTH */             {MAP_CHAR_LEN("CharScaleWidth")},
/* 0581 TAB_STOP_DISTANCE */            {MAP_CHAR_LEN("TabStopDistance")},
/* 0582 IS_WIDTH_RELATIVE */            {MAP_CHAR_LEN("IsWidthRelative")},
/* 0583 CHAR_RELIEF */                  {MAP_CHAR_LEN("CharRelief")},
/* 0584 IS_HIDDEN */                    {MAP_CHAR_LEN("IsHidden")},
/* 0585 IS_CONDITION_TRUE */            {MAP_CHAR_LEN("IsConditionTrue")},
/* 0586 TWO_DIGIT_YEAR */               {MAP_CHAR_LEN("TwoDigitYear")},
/* 0587 PROTECTION_KEY */               {MAP_CHAR_LEN("ProtectionKey")},
/* 0588 REDLINE_PROTECTION_KEY */       {MAP_CHAR_LEN("RedlineProtectionKey")},
/* 0589 AUTOMATIC_DISTANCE */           {MAP_CHAR_LEN("AutomaticDistance")},
/* 0590 AUTOMATIC_CONTROL_FOCUS */      {MAP_CHAR_LEN("AutomaticControlFocus")},
/* 0591 APPLY_FORM_DESIGN_MODE */       {MAP_CHAR_LEN("ApplyFormDesignMode")},
/* 0592 LOCALE */                       {MAP_CHAR_LEN("Locale")},
/* 0593 SORT_ALGORITHM */               {MAP_CHAR_LEN("SortAlgorithm")},
/* 0594 FRAME_HEIGHT_ABSOLUTE */        {MAP_CHAR_LEN("FrameHeightAbsolute")},
/* 0596 FRAME_HEIGHT_PERCENT */         {MAP_CHAR_LEN("FrameHeightPercent")},
/* 0597 FRAME_ISAUTOMATIC_HEIGHT */     {MAP_CHAR_LEN("FrameIsAutomaticHeight")},
/* 0598 FRAME_WIDTH_ABSOLUTE */         {MAP_CHAR_LEN("FrameWidthAbsolute")},
/* 0599 FRAME_WIDTH_PERCENT */          {MAP_CHAR_LEN("FrameWidthPercent")},
/* 0600 PARA_STYLEHEADING */            {MAP_CHAR_LEN("ParaStyleHeading")},
/* 0601 PARA_STYLELEVEL1 */             {MAP_CHAR_LEN("ParaStyleLevel1")},
/* 0602 PARA_STYLELEVEL10 */            {MAP_CHAR_LEN("ParaStyleLevel10")},
/* 0603 PARA_STYLELEVEL2 */             {MAP_CHAR_LEN("ParaStyleLevel2")},
/* 0604 PARA_STYLELEVEL3 */             {MAP_CHAR_LEN("ParaStyleLevel3")},
/* 0605 PARA_STYLELEVEL4 */             {MAP_CHAR_LEN("ParaStyleLevel4")},
/* 0606 PARA_STYLELEVEL5 */             {MAP_CHAR_LEN("ParaStyleLevel5")},
/* 0607 PARA_STYLELEVEL6 */             {MAP_CHAR_LEN("ParaStyleLevel6")},
/* 0608 PARA_STYLELEVEL7 */             {MAP_CHAR_LEN("ParaStyleLevel7")},
/* 0609 PARA_STYLELEVEL8 */             {MAP_CHAR_LEN("ParaStyleLevel8")},
/* 0610 PARA_STYLELEVEL9 */             {MAP_CHAR_LEN("ParaStyleLevel9")},
/* 0611 PARA_STYLESEPARATOR */          {MAP_CHAR_LEN("ParaStyleSeparator")},
/* 0612 MACRO_LIBRARY */                {MAP_CHAR_LEN("MacroLibrary")},
/* 0613 CELL_NAME */                    {MAP_CHAR_LEN("CellName")},
/* 0614 PARA_USER_DEFINED_ATTRIBUTES */ {MAP_CHAR_LEN("ParaUserDefinedAttributes")},
/* 0615 UNO_NAME_MERGE_LAST_PARA */     {MAP_CHAR_LEN("MergeLastPara")},
/* 0616 UNO_NAME_WRITING_MODE */        {MAP_CHAR_LEN("WritingMode")},
/* 0617 UNO_NAME_GRID_COLOR */          {MAP_CHAR_LEN("GridColor")},
/* 0618 UNO_NAME_GRID_LINES */          {MAP_CHAR_LEN("GridLines")},
/* 0619 UNO_NAME_GRID_BASE_HEIGHT */    {MAP_CHAR_LEN("GridBaseHeight")},
/* 0620 UNO_NAME_GRID_RUBY_HEIGHT */    {MAP_CHAR_LEN("GridRubyHeight")},
/* 0621 UNO_NAME_GRID_MODE */           {MAP_CHAR_LEN("GridMode")},
/* 0622 UNO_NAME_GRID_RUBY_BELOW */     {MAP_CHAR_LEN("RubyBelow")},
/* 0623 UNO_NAME_GRID_PRINT */          {MAP_CHAR_LEN("GridPrint")},
/* 0624 UNO_NAME_GRID_DISPLAY */        {MAP_CHAR_LEN("GridDisplay")},
/* 0625 UNO_NAME_SNAP_TO_GRID */        {MAP_CHAR_LEN("SnapToGrid")},
/* 0626 UNO_NAME_DONT_BALANCE_TEXT_COLUMNS */{MAP_CHAR_LEN("DontBalanceTextColumns")},
/* 0627 UNO_NAME_IS_CURRENTLY_VISIBLE */{MAP_CHAR_LEN("IsCurrentlyVisible")},
/* 0628 UNO_NAME_ANCHOR_POSITION */     {MAP_CHAR_LEN("AnchorPosition")},
/* 0629 UNO_NAME_TEXT_READING */        {MAP_CHAR_LEN("TextReading")},
/* 0630 UNO_NAME_PRIMARY_KEY_READING */ {MAP_CHAR_LEN("PrimaryKeyReading")},
/* 0631 UNO_NAME_SECONDARY_KEY_READING */   {MAP_CHAR_LEN("SecondaryKeyReading")},
/* 0632 UNO_NAME_BACK_GRAPHIC_TRANSPARENCY*/ {MAP_CHAR_LEN("BackGraphicTransparency")},
/* 0633 UNO_NAME_BACK_COLOR_R_G_B */        {MAP_CHAR_LEN("BackColorRGB")},
/* 0634 UNO_NAME_BACK_COLOR_TRANSPARENCY */ {MAP_CHAR_LEN("BackColorTransparency")},
/* 0635 UNO_NAME_HEADER_DYNAMIC_SPACING */ {MAP_CHAR_LEN("HeaderDynamicSpacing")},
/* 0636 UNO_NAME_FOOTER_DYNAMIC_SPACING */ {MAP_CHAR_LEN("FooterDynamicSpacing")},
/* 0637 UNO_NAME_BASIC_LIBRARIES */ {MAP_CHAR_LEN("BasicLibraries")},
/* 0638 UNO_NAME_IS_FIXED_LANGUAGE */ {MAP_CHAR_LEN("IsFixedLanguage")},
/* 0639 UNO_NAME_SELECTION */  {MAP_CHAR_LEN("Selection")},
/* 0640 UNO_NAME_RESULT_SET */  {MAP_CHAR_LEN("ResultSet")},
/* 0641 UNO_NAME_CONNECTION */  {MAP_CHAR_LEN("ActiveConnection")},
/* 0642 UNO_NAME_MODEL */  {MAP_CHAR_LEN("Model")},
/* 0643 UNO_NAME_DATA_SOURCE_NAME */  {MAP_CHAR_LEN("DataSourceName")},
/* 0644 UNO_NAME_DATA_COMMAND */  {MAP_CHAR_LEN("DataCommand")},
/* 0645 UNO_NAME_FILTER */  {MAP_CHAR_LEN("Filter")},
/* 0646 UNO_NAME_DOCUMENT_URL */  {MAP_CHAR_LEN("DocumentURL")},
/* 0647 UNO_NAME_OUTPUT_URL */  {MAP_CHAR_LEN("OutputURL")},
/* 0648 UNO_NAME_OUTPUT_TYPE */  {MAP_CHAR_LEN("OutputType")},
/* 0649 UNO_NAME_ESCAPE_PROCESSING */  {MAP_CHAR_LEN("EscapeProcessing")},
/* 0650 UNO_NAME_SINGLE_PRINT_JOBS */  {MAP_CHAR_LEN("SinglePrintJobs")},
/* 0651 UNO_NAME_FILE_NAME_FROM_COLUMN */  {MAP_CHAR_LEN("FileNameFromColumn")},
/* 0652 UNO_NAME_FILE_NAME_PREFIX */  {MAP_CHAR_LEN("FileNamePrefix")},
/* 0653 UNO_NAME_CHAR_STYLE_NAMES */  {MAP_CHAR_LEN("CharStyleNames")},
/* 0654 UNO_NAME_DAD_COMMAND */  {MAP_CHAR_LEN("Command")},
/* 0655 UNO_NAME_DAD_COMMAND_TYPE */  {MAP_CHAR_LEN("CommandType")},
/* 0655 UNO_NAME_CLSID*/              {MAP_CHAR_LEN("CLSID")},
/* 0657 UNO_NAME_COMPONENT*/              {MAP_CHAR_LEN("Component")},
/* 0658 UNO_NAME_SECT_LEFT_MARGIN*/              {MAP_CHAR_LEN("SectionLeftMargin")},
/* 0659 UNO_NAME_SECT_RIGHT_MARGIN*/              {MAP_CHAR_LEN("SectionRightMargin")},
/* 0660 UNO_NAME_PARA_IS_CONNECT_BORDER */{MAP_CHAR_LEN("ParaIsConnectBorder")},
/* 0661 UNO_NAME_ITEMS*/ {MAP_CHAR_LEN("Items")},
/* 0662 UNO_NAME_SELITEM*/ {MAP_CHAR_LEN("SelectedItem")}
};

#ifdef DBG_UTIL
const SwPropNameLen& GetPropName( USHORT nId )
{
    DBG_ASSERT( SW_PROPNAME_BEGIN <= nId && nId < SW_PROPNAME_END,
                "GetPropName(): Wrong index" );
    return aPropNameTab[ nId - SW_PROPNAME_BEGIN];
}
#endif

}

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
